Skip to Content
0

"java.lang.VerifyError: Expecting a stack map frame" when opening custom iView

Jun 30, 2017 at 08:12 AM

310

avatar image

Hello experts,

I have developed an iView using the JSP DynPage concept (i.e. portal component extending PageProcessorComponent plus Java bean for exchanging data with my JSP). This has been working perfectly on NW 7.3 and NW 7.4 for many years.

On NW 7.5 we are encountering the following error when the iview is opened:

500 Internal Server Error
Message:
Cannot process an HTTP request to servlet [prt] in [irj] web application. 
[EXCEPTION] 
java.lang.VerifyError: Expecting a stack map frame
Exception Details:
  Location:
    PRT_jsp_WEB_2d_INF_pagelet_FsIntegrationAdmin_1498722360657._doContent(Lcom/sapportals/portal/prt/component/IPortalComponentRequest;Lcom/sapportals/portal/prt/component/IPortalComponentResponse;)V @31559: nop
  Reason:
    Expected stackmap frame at this location.
Bytecode:
    0x0000000: 1307 15b8 0712 3aae 2b03 b900 0b02 0012
....

This error seems to indicate a problem with the bytecode.

Theses are my findings so far:

  • the portal component was compiled with Oracle JDK 1.8 using source and target 1.8
  • the class file compiled by the Portal upon first access is also 1.8.
  • the doContent() method is not implemented in my portal component, it is present in the superclass which is SAP's PageProcessorComponent
  • the error only occurs on some installations, other systems are not affected. This seems to indicate that some configuration may be responsible.

I have no idea how to analyse this further - is there something wrong with my code or the way it is compiled? Or is there a setting in NetWeaver that cannot deal with the compiled code?

Any ideas would be greatly appreciated.

Best regards,

Tanja

10 |10000 characters needed characters left characters exceeded
* Please Login or Register to Answer, Follow or Comment.

2 Answers

Matt Fraser
Jul 12, 2017 at 03:48 PM
0

Hi Tanja,

I added a few more secondary tags to your question to help bring about some relevant visibility.

I'm not a Java developer myself, so no expert on this, but I'm pretty sure NetWeaver Java 7.5 is only compatible with the SAPJVM (8.1) -- per the PAM -- and you mention that you compiled your code with Oracle JDK 1.8. Can you recompile with the SAPJVM?

Cheers,
Matt

Share
10 |10000 characters needed characters left characters exceeded
Tanja Großmüller Jul 14, 2017 at 07:30 AM
0

Hi Matt,

thanks for your input. The compatibility you mention relates to NetWeaver's runtime environment (i.e. NW only runs on SAP JVM). As far as compilation is concerned, it should not matter whether Oracle or SAP is used (that's the theory :-))

And indeed, we seem to have identified the cause of the issue: looks like Wily's Introscope JAVA Agent is to blame. Once it is switched off, the iView can be opened.

Now that we have found the cause we have to see how to solve that.

Regards,

Tanja

Share
10 |10000 characters needed characters left characters exceeded